import { EndpointParameterInstructions } from "@smithy/middleware-endpoint";
import { Command as $Command } from "@smithy/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@smithy/types";
import {
  CodeDeployClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../CodeDeployClient";
import {
  BatchGetApplicationsInput,
  BatchGetApplicationsOutput,
} from "../models/models_0";
export { __MetadataBearer, $Command };
export interface BatchGetApplicationsCommandInput
  extends BatchGetApplicationsInput {}
export interface BatchGetApplicationsCommandOutput
  extends BatchGetApplicationsOutput,
    __MetadataBearer {}
export declare class BatchGetApplicationsCommand extends $Command<
  BatchGetApplicationsCommandInput,
  BatchGetApplicationsCommandOutput,
  CodeDeployClientResolvedConfig
> {
  readonly input: BatchGetApplicationsCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: BatchGetApplicationsCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: CodeDeployClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<
    BatchGetApplicationsCommandInput,
    BatchGetApplicationsCommandOutput
  >;
  private serialize;
  private deserialize;
}
