import { EndpointParameterInstructions } from "@smithy/middleware-endpoint";
import { Command as $Command } from "@smithy/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@smithy/types";
import {
  CodeDeployClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../CodeDeployClient";
import {
  BatchGetDeploymentGroupsInput,
  BatchGetDeploymentGroupsOutput,
} from "../models/models_0";
export { __MetadataBearer, $Command };
export interface BatchGetDeploymentGroupsCommandInput
  extends BatchGetDeploymentGroupsInput {}
export interface BatchGetDeploymentGroupsCommandOutput
  extends BatchGetDeploymentGroupsOutput,
    __MetadataBearer {}
export declare class BatchGetDeploymentGroupsCommand extends $Command<
  BatchGetDeploymentGroupsCommandInput,
  BatchGetDeploymentGroupsCommandOutput,
  CodeDeployClientResolvedConfig
> {
  readonly input: BatchGetDeploymentGroupsCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: BatchGetDeploymentGroupsCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: CodeDeployClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<
    BatchGetDeploymentGroupsCommandInput,
    BatchGetDeploymentGroupsCommandOutput
  >;
  private serialize;
  private deserialize;
}
