import { EndpointParameterInstructions } from "@smithy/middleware-endpoint";
import { Command as $Command } from "@smithy/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@smithy/types";
import {
  CodeDeployClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../CodeDeployClient";
import {
  BatchGetDeploymentTargetsInput,
  BatchGetDeploymentTargetsOutput,
} from "../models/models_0";
export { __MetadataBearer, $Command };
export interface BatchGetDeploymentTargetsCommandInput
  extends BatchGetDeploymentTargetsInput {}
export interface BatchGetDeploymentTargetsCommandOutput
  extends BatchGetDeploymentTargetsOutput,
    __MetadataBearer {}
export declare class BatchGetDeploymentTargetsCommand extends $Command<
  BatchGetDeploymentTargetsCommandInput,
  BatchGetDeploymentTargetsCommandOutput,
  CodeDeployClientResolvedConfig
> {
  readonly input: BatchGetDeploymentTargetsCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: BatchGetDeploymentTargetsCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: CodeDeployClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<
    BatchGetDeploymentTargetsCommandInput,
    BatchGetDeploymentTargetsCommandOutput
  >;
  private serialize;
  private deserialize;
}
