import { EndpointParameterInstructions } from "@smithy/middleware-endpoint";
import { Command as $Command } from "@smithy/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@smithy/types";
import {
  CodeDeployClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../CodeDeployClient";
import {
  BatchGetDeploymentsInput,
  BatchGetDeploymentsOutput,
} from "../models/models_0";
export { __MetadataBearer, $Command };
export interface BatchGetDeploymentsCommandInput
  extends BatchGetDeploymentsInput {}
export interface BatchGetDeploymentsCommandOutput
  extends BatchGetDeploymentsOutput,
    __MetadataBearer {}
export declare class BatchGetDeploymentsCommand extends $Command<
  BatchGetDeploymentsCommandInput,
  BatchGetDeploymentsCommandOutput,
  CodeDeployClientResolvedConfig
> {
  readonly input: BatchGetDeploymentsCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: BatchGetDeploymentsCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: CodeDeployClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<BatchGetDeploymentsCommandInput, BatchGetDeploymentsCommandOutput>;
  private serialize;
  private deserialize;
}
