import { EndpointParameterInstructions } from "@smithy/middleware-endpoint";
import { Command as $Command } from "@smithy/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@smithy/types";
import {
  CodeDeployClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../CodeDeployClient";
import {
  CreateDeploymentGroupInput,
  CreateDeploymentGroupOutput,
} from "../models/models_0";
export { __MetadataBearer, $Command };
export interface CreateDeploymentGroupCommandInput
  extends CreateDeploymentGroupInput {}
export interface CreateDeploymentGroupCommandOutput
  extends CreateDeploymentGroupOutput,
    __MetadataBearer {}
export declare class CreateDeploymentGroupCommand extends $Command<
  CreateDeploymentGroupCommandInput,
  CreateDeploymentGroupCommandOutput,
  CodeDeployClientResolvedConfig
> {
  readonly input: CreateDeploymentGroupCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: CreateDeploymentGroupCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: CodeDeployClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<
    CreateDeploymentGroupCommandInput,
    CreateDeploymentGroupCommandOutput
  >;
  private serialize;
  private deserialize;
}
