import { EndpointParameterInstructions } from "@smithy/middleware-endpoint";
import { Command as $Command } from "@smithy/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@smithy/types";
import {
  CodeDeployClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../CodeDeployClient";
import {
  ListDeploymentTargetsInput,
  ListDeploymentTargetsOutput,
} from "../models/models_0";
export { __MetadataBearer, $Command };
export interface ListDeploymentTargetsCommandInput
  extends ListDeploymentTargetsInput {}
export interface ListDeploymentTargetsCommandOutput
  extends ListDeploymentTargetsOutput,
    __MetadataBearer {}
export declare class ListDeploymentTargetsCommand extends $Command<
  ListDeploymentTargetsCommandInput,
  ListDeploymentTargetsCommandOutput,
  CodeDeployClientResolvedConfig
> {
  readonly input: ListDeploymentTargetsCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: ListDeploymentTargetsCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: CodeDeployClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<
    ListDeploymentTargetsCommandInput,
    ListDeploymentTargetsCommandOutput
  >;
  private serialize;
  private deserialize;
}
