import { EndpointParameterInstructions } from "@smithy/middleware-endpoint";
import { Command as $Command } from "@smithy/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@smithy/types";
import {
  CodeDeployClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../CodeDeployClient";
import {
  ListGitHubAccountTokenNamesInput,
  ListGitHubAccountTokenNamesOutput,
} from "../models/models_0";
export { __MetadataBearer, $Command };
export interface ListGitHubAccountTokenNamesCommandInput
  extends ListGitHubAccountTokenNamesInput {}
export interface ListGitHubAccountTokenNamesCommandOutput
  extends ListGitHubAccountTokenNamesOutput,
    __MetadataBearer {}
export declare class ListGitHubAccountTokenNamesCommand extends $Command<
  ListGitHubAccountTokenNamesCommandInput,
  ListGitHubAccountTokenNamesCommandOutput,
  CodeDeployClientResolvedConfig
> {
  readonly input: ListGitHubAccountTokenNamesCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: ListGitHubAccountTokenNamesCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: CodeDeployClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<
    ListGitHubAccountTokenNamesCommandInput,
    ListGitHubAccountTokenNamesCommandOutput
  >;
  private serialize;
  private deserialize;
}
